local Delleren = DellerenAddon

Delleren.Utils = {}

function Delleren.Utils.FindValueKey( table, value )
	for k,v in pairs( table ) do
		if v == value then return k end
	end
end

-------------------------------------------------------------------------------
function Delleren.Utils.GetIcon( id, isitem )
	local icon = nil
	
	if id then
		if isitem then
			icon = select( 10, GetItemInfo(id) )
		else
			icon = select( 3, GetSpellInfo(id) )
		end	
	end
	
	return icon or "Interface\\Icons\\trade_engineering"
end

-------------------------------------------------------------------------------
function Delleren.Utils.GetSpellName( id, isitem )
	local name = nil
	
	if id then
		if isitem then
			name = GetItemInfo(id)
		else
			name = GetSpellInfo(id)
		end	
	end
	
	return name or "<Invalid Spell/Item>"
end

-------------------------------------------------------------------------------
-- Returns a unit name colored by their class.
--
function Delleren.Utils.UnitNameColored( unit )
	local _,cls = UnitClass(unit)
	
	return "|c" .. RAID_CLASS_COLORS[cls].colorStr .. UnitName(unit) .. "|r"
end

-------------------------------------------------------------------------------
function Delleren.Utils.GetFramePoints( frame )
	local points = {}
	for i = 1, frame:GetNumPoints() do
		local point,_,relpoint,x,y = frame:GetPoint( i )
		points[i] = { point, relpoint, x, y }
	end
	return points
end

-------------------------------------------------------------------------------
function Delleren.Utils.ApplyFramePoints( frame, parent, points )
	frame:ClearAllPoints()
	
	if #points == 0 then
		frame:SetPoint( "CENTER", parent )
	else
		for i = 1, #points do
			frame:SetPoint( points[i][1], parent, 
					points[i][2], points[i][3], points[i][4] )
		end
	end
end

-------------------------------------------------------------------------------
function Delleren.Utils.NoRaidAssist()
	return not IsInRaid() or not (UnitIsGroupLeader("player") 
	                              or UnitIsGroupAssistant("player") )
end